//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrLimeGreen
#property indicator_color4  clrPaleVioletRed
#property indicator_color5  clrPaleVioletRed
#property indicator_color6  clrSilver
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property strict

//
//
//
//
//

enum enMaTypes
{
   ma_sma,    // Simple moving average
   ma_ema,    // Exponential moving average
   ma_smma,   // Smoothed MA
   ma_lwma,   // Linear weighted MA
   ma_tema    // Tripple exponential moving average
};

extern ENUM_TIMEFRAMES    TimeFrame          = PERIOD_CURRENT; // Time frame
extern int                SZOPeriod          = 14;             // Sentiment zone period
extern enMaTypes          SZOMethod          = ma_tema;        // Sentiment zone ma method
extern ENUM_APPLIED_PRICE Price              = PRICE_CLOSE;    // Price
extern int                PriceFiltering     = 14;             // Price filtering period
extern enMaTypes          PriceFilteringMode = ma_sma;         // Price filtering mode
extern int                SZOLevelsPeriod    = 30;             // Levels period
extern double             SZOPercent         = 95;             // Levels percent
extern int                AveragePeriod      = 14;             // Average period
extern enMaTypes          AverageType        = ma_ema;         // Average type for sentiment zone signal line
extern bool               AlertsOn           = false;          // Turn alerts on
extern bool               AlertsOnCurrent    = true;           // Alerts on current
extern bool               AlertsMessage      = true;           // Alerts message
extern bool               AlertsSound        = false;          // Alerts sound
extern bool               AlertsEmail        = false;          // Alerts email
extern bool               Interpolate        = true;           // Interpolate

double upz[],dnz[],szo[],szoda[],szodb[],avg[],prices[],trend[];
string indicatorFileName;
bool   returnBars;
#define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SZOPeriod,SZOMethod,Price,PriceFiltering,PriceFilteringMode,SZOLevelsPeriod,SZOPercent,AveragePeriod,AverageType,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,_buff,_y)

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,upz);
   SetIndexBuffer(1,dnz);
   SetIndexBuffer(2,szo);
   SetIndexBuffer(3,szoda);
   SetIndexBuffer(4,szodb);
   SetIndexBuffer(5,avg);
   SetIndexBuffer(6,prices);
   SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      IndicatorShortName(timeFrameToString(TimeFrame)+" Sentiment zone oscillator ("+(string)SZOPeriod+","+(string)SZOLevelsPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { upz[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != _Period)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
               if (trend[limit]== 1) CleanPoint(limit,szoda,szodb);
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     upz[i]   = _mtfCall(0,y);
                     dnz[i]   = _mtfCall(1,y);
                     szo[i]   = _mtfCall(2,y);
                     avg[i]   = _mtfCall(5,y);
                     trend[i] = _mtfCall(7,y);
                     szoda[i] = EMPTY_VALUE;
                     szodb[i] = EMPTY_VALUE;
                  
                     //
                     //
                     //
                     //
                     //
                  
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                        #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                        int n,k; datetime ctime = iTime(NULL,TimeFrame,y);
                           for(n = 1; (i+n)<Bars && Time[i+n] >= ctime; n++) continue;	
                           for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                           {
                              _interpolate(upz);
                              _interpolate(dnz);
                              _interpolate(szo);
                              _interpolate(avg);
                           }                              
               }
               for(int i=limit; i>=0; i--) if (trend[i]==-1) PlotPoint(i,szoda,szodb,szo);
               return(0);
            }
  

   //
   //
   //
   //
   //

   if (trend[limit]== 1) CleanPoint(limit,szoda,szodb);
   for(int i=limit; i>=0; i--)
   {
      prices[i] = iCustomMa(PriceFilteringMode,iMA(NULL,0,1,0,MODE_SMA,Price,i),PriceFiltering,i,Bars,0);
      double useValue = (i<Bars-1) ? (prices[i]>prices[i+1]) ? 1 : (prices[i]<prices[i+1]) ? -1 : 0 : 0;
      
      //
      //
      //
      //
      //
         
       szo[i] =  iCustomMa(SZOMethod,useValue,SZOPeriod,i,Bars,1);
            double hi = szo[ArrayMaximum(szo,SZOLevelsPeriod,i)];
            double lo = szo[ArrayMinimum(szo,SZOLevelsPeriod,i)];
            double rn = hi-lo;
         upz[i]   = lo+rn*SZOPercent/100.0;
         dnz[i]   = hi-rn*SZOPercent/100.0;
         avg[i]   = iCustomMa(AverageType,szo[i],AveragePeriod,i,Bars,2);
         trend[i] = (szo[i]>avg[i]) ? 1 : (szo[i]<avg[i]) ? -1 : (i<Bars-1) ? trend[i+1] : 0;
         szoda[i] = EMPTY_VALUE;
         szodb[i] = EMPTY_VALUE;
               if (trend[i]==-1) PlotPoint(i,szoda,szodb,szo);
   }               
   if (AlertsOn)
   {
      int whichBar = 1; if (AlertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(" sentiment zone oscillator state changed to up");
         if (trend[whichBar] ==-1) doAlert(" sentiment zone oscillator state changed to down");
      }         
   }
   return(0);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define _maInstances 3
#define _maWorkBufferx1 _maInstances
#define _maWorkBufferx3 _maInstances*3
double iCustomMa(int mode, double price, double length, int r, int bars, int instanceNo=0)
{
   bars = Bars; r=bars-r-1;
   switch (mode)
   {
      case ma_sma   : return(iSma(price,(int)length,r,bars,instanceNo));
      case ma_ema   : return(iEma(price,length,r,bars,instanceNo));
      case ma_smma  : return(iSmma(price,(int)length,r,bars,instanceNo));
      case ma_lwma  : return(iLwma(price,(int)length,r,bars,instanceNo));
      case ma_tema  : return(iTema(price,(int)length,r,bars,instanceNo));
      default       : return(price);
   }
}

//
//
//
//
//

double workSma[][_maWorkBufferx1];
double iSma(double price, int period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= _bars) ArrayResize(workSma,_bars); int k=1;

   workSma[r][instanceNo+0] = price;
   double tavg = price; for(; k<period && (r-k)>=0; k++) tavg += workSma[r-k][instanceNo+0];  tavg /= (double)k;
   return(tavg);
}

//
//
//
//
//

double workEma[][_maWorkBufferx1];
double iEma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= _bars) ArrayResize(workEma,_bars);

   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//
//
//

double workSmma[][_maWorkBufferx1];
double iSmma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= _bars) ArrayResize(workSmma,_bars);

   workSmma[r][instanceNo] = price;
   if (r>1 && period>1)
          workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//
//
//
//
//

double workLwma[][_maWorkBufferx1];
double iLwma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workLwma,0)!= _bars) ArrayResize(workLwma,_bars);
   
   workLwma[r][instanceNo] = price; if (period<1) return(price);
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//
//
//
//
//

double workTema[][_maWorkBufferx3];
#define _tema1 0
#define _tema2 1
#define _tema3 2

double iTema(double price, double period, int r, int bars, int instanceNo=0)
{
   if (ArrayRange(workTema,0)!= bars) ArrayResize(workTema,bars); instanceNo*=3;

   //
   //
   //
   //
   //
      
   workTema[r][_tema1+instanceNo] = price;
   workTema[r][_tema2+instanceNo] = price;
   workTema[r][_tema3+instanceNo] = price;
   if (r>0 && period>1)
   {
      double alpha = 2.0 / (1.0+period);
          workTema[r][_tema1+instanceNo] = workTema[r-1][_tema1+instanceNo]+alpha*(price                         -workTema[r-1][_tema1+instanceNo]);
          workTema[r][_tema2+instanceNo] = workTema[r-1][_tema2+instanceNo]+alpha*(workTema[r][_tema1+instanceNo]-workTema[r-1][_tema2+instanceNo]);
          workTema[r][_tema3+instanceNo] = workTema[r-1][_tema3+instanceNo]+alpha*(workTema[r][_tema2+instanceNo]-workTema[r-1][_tema3+instanceNo]); }
   return(workTema[r][_tema3+instanceNo]+3.0*(workTema[r][_tema1+instanceNo]-workTema[r][_tema2+instanceNo]));
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (AlertsMessage) Alert(message);
             if (AlertsEmail)   SendMail(_Symbol+" sentiment zone oscillator",message);
             if (AlertsSound)   PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}